
/*
COPYRIGHT: Unless otherwise noted, all files are Copyright (c) 1992-1993
Commodore-Amiga, Inc.  All rights reserved.

DISCLAIMER: This software is provided "as is".  No representations or
warranties are made with respect to the accuracy, reliability, performance,
currentness, or operation of this software, and all use is at your own risk.
Neither commodore nor the authors assume any responsibility or liability
whatsoever with respect to your use of this software.
*/


/****************************************************************************/


#ifndef GADGETS_H
#define GADGETS_H


/****************************************************************************/


/* commands that can be generated by gadgets */
enum
{
    /* generic options, available for all requester types */
    ID_REFOBJECT,
    ID_INITIALLEFTEDGE,
    ID_INITIALTOPEDGE,
    ID_INITIALWIDTH,
    ID_INITIALHEIGHT,
    ID_TITLETEXT,
    ID_POSITIVETEXT,
    ID_NEGATIVETEXT,
    ID_FONTNAME,
    ID_FONTSIZE,
    ID_LOCALE,
    ID_PRIVATEIDCMP,
    ID_SLEEPWINDOW,
    ID_INTUIMSGFUNC,
    ID_FILTERFUNC,
    ID_REQTYPE,
    ID_TEST,

    /* file requester options */
    ID_INITIALFILE,
    ID_INITIALDRAWER,
    ID_INITIALPATTERN,
    ID_ACCEPTPATTERN,
    ID_REJECTPATTERN,
    ID_DOSAVEMODE,
    ID_DOMULTISELECT,
    ID_DOPATTERNS,
    ID_DRAWERSONLY,
    ID_REJECTICONS,
    ID_FILTERDRAWERS,

    /* font requester options */
    ID_INITIALNAME,
    ID_INITIALSIZE,
    ID_INITIALFRONTPEN,
    ID_INITIALBACKPEN,
    ID_INITIALDRAWMODE,
    ID_INITIALSTYLE,
    ID_INITIALSTYLE_PLAIN,
    ID_INITIALSTYLE_BOLD,
    ID_INITIALSTYLE_ITALIC,
    ID_INITIALSTYLE_UNDERLINE,
    ID_DOFRONTPEN,
    ID_DOBACKPEN,
    ID_DOSTYLE,
    ID_DODRAWMODE,
    ID_FIXEDWIDTHONLY,
    ID_MINHEIGHT,
    ID_MAXHEIGHT,
    ID_MAXFRONTPEN,
    ID_MAXBACKPEN,
    ID_FRONTPENS,
    ID_BACKPENS,
    ID_MODELIST,

    /* screen mode requester options */
    ID_INITIALDISPLAYID,
    ID_INITIALDISPLAYWIDTH,
    ID_INITIALDISPLAYHEIGHT,
    ID_INITIALDISPLAYDEPTH,
    ID_INITIALOVERSCANTYPE,
    ID_INITIALINFOLEFTEDGE,
    ID_INITIALINFOTOPEDGE,
    ID_INITIALINFOOPENED,
    ID_INITIALAUTOSCROLL,
    ID_DOWIDTH,
    ID_DOHEIGHT,
    ID_DODEPTH,
    ID_DOOVERSCANTYPE,
    ID_DOAUTOSCROLL,
    ID_CUSTOMSMLIST,
    ID_PROPERTYFLAGS,
    ID_PROPERTYMASK,
    ID_MINWIDTH_SM,
    ID_MAXWIDTH_SM,
    ID_MINHEIGHT_SM,
    ID_MAXHEIGHT_SM,
    ID_MINDEPTH,
    ID_MAXDEPTH,

    ID_MAX
};

/* different possible states of the ID_REQTYPE gadget */
enum
{
    REQ_FILE,
    REQ_FONT,
   REQ_SCREENMODE
};

/* different possible states of the ID_REFOBJECT gadget */
enum
{
    REF_NONE,
    REF_WINDOW,
    REF_SCREEN,
    REF_PUBSCREENNAME
};


/*****************************************************************************/


#endif /* GADGETS_H */
